(function () {
    'use strict';

    var cssOrderAttributeAdminClass = function (options) {
        this.init(options);
    };

    cssOrderAttributeAdminClass.VERSION = '2.0.0';
    cssOrderAttributeAdminClass.DEFAULTS = { 
  			showDebug : true,
				templateSelectors:  {
					'nova': {
						'selector': {
							selector_position: "prepend",
							selector: "#complete_order"
						},
					},
					'snackys': {
						'selector': {
							selector_position: "prepend",
							selector: "#complete_order"
						},
					},
					'admorris': {
						'selector': {
							selector_position: "prepend",
							selector: "#complete_order"
						},
					},
					'salepix': {
						'selector': {
							selector_position: "prepend",
							selector: "#complete_order"
						},
					},
					'easytemplate': {
						'selector': {
							selector_position: "prepend",
							selector: "#complete_order"
						},
					},
				},

		};

    cssOrderAttributeAdminClass.prototype = {

        constructor: cssOrderAttributeAdminClass,

        init: function (options) {
            this.options = $.extend({}, cssOrderAttributeAdminClass.DEFAULTS, options);
            var that = this;
						that.initAttrType("select[name='cType']");
						that.initoptionButtons();
						that.checkOptionButtonStatus();
						that.docu();
						that.setAction();
        },

        register: function(options) {
        	var that=this;
        	this.debug("ich starte cssOrderAttributeAdminClass.VERSION " +  this.__proto__.constructor.VERSION);
					that.initTemplateSelectors();
        },
        
        debug: function(s) {
        	if(this.options.showDebug) {
        		console.log(s);
        	}
        },

        _set: function(key,value) {
        	this.options.key = value;
        },


			initAttrType: function(el) {
					var that = this;
				$(document).on("change", el, function() {
					that.debug("Function: initAttrType, event: change, selector: " + el +  "value: " + $(this).val());
					switch($(this).val()) {
						case 'radio':
						case 'checkbox':
						case 'dropdown':
						case 'text':
						case 'date':
						case 'time':
						case 'textarea':
						case 'datetime-local':
							$(".section-css-options").slideUp();
							$(".css-" + $(this).val()).slideDown();
							$(".css-" + $(this).val()).find("input").attr("required",true);
							break;
						default:
							$(".css-" + $(this).val()).find("input").attr("required",false);
							$(".css-radio,.css-multicheckbox,.css-dropdown").slideUp();
							break;
					}
				});
			},

			docu: function() {
				var that = this;
				$(document).on("click", "[data-section]", function () {
					var pluginID = $(this).closest("[data-plugin]").data('plugin');
					var data = "io=" + pluginID +  "&jtl_token=" + $(this).closest("[data-session]").data("session") + "&action=docu&section=" + $(this).data('section');
					var url = $(this).closest("[data-io]").data("io");
					that.post_data(url, data);
				});
			},

			setAction: function() {
					var that=this;
				$(document).on("click", "[data-attributeupdate]", function () {
					var action = $(this).data('action');
					var id = $(this).data('id');
					var pluginID = $(this).closest("#Attributeslist").data('plugin');
					var data = "io=" + pluginID +  "&jtl_token=" + $(this).closest("#Attributeslist").data("session") + "&action="+ $(this).data('action') + "&id=" + $(this).data('id');
					var url = $(this).closest("#Attributeslist").data("io");
					that.post_data(url, data);
				});
			},

			sortAttributes: function(el) {
				var that = this;
				var data  = "";
				var pluginID = $("#Attributeslist").data("plugin");

				$(el).find('[data-type="sort"]').each( function() {
					data = data + "&data[" + $(this).attr('name') +"]=" + $(this).val();
				});
				var data = "io=" + pluginID +  "&jtl_token=" + $("#Attributeslist").data("session") + "&action=sortAttributes" + data;
				var url = $("#Attributeslist").data("io");
				that.post_data(url, data);
			},

			checkOptionButtonStatus : function() {
					console.log("function: checkOptionButtonStatus");
				$(".section-css-options").each(function() {
					console.log(this);
					if($(this).find(".input-group").length<2) {
						$(this).find(".css-minus").attr("disabled",true);
					} else {
						$(this).find(".css-minus").attr("disabled",false);
					}
				});
			},


			initoptionButtons: function() {
					var that=this;
				$(document).on("click", ".css-options .css-plus", function (e) {
					e.stopPropagation();
					var el = $(this).closest(".input-group").last().clone();
					$(el).find("input").val("");
					$(el).find("select").val("");
					$("#Optionslist").append(el);
					that.checkOptionButtonStatus();
				});

				$(document).on("click", ".css-options .css-minus", function (e) {
					e.stopPropagation();
					$(this).closest(".css-options").remove();
					that.checkOptionButtonStatus();
				});
			},

			initTemplateSelectors: function() {
				var that = this;
				$(document).on("click", "[data-template]", function() {
					var tSelectors = that.options.templateSelectors[$(this).data('template')];
					console.log(tSelectors);
					Object.entries(tSelectors).forEach(entry => {
						const [key, value] = entry;
						Object.entries(value).forEach(entry => {
							const [key, value] = entry;
							console.log(key,value);
							$("[name='" + key + "']").val(value);
						});
					});
				});
			},


			post_data: function (url, data) {
        	var that = this;
					that.debug(url);
	      	jQuery.ajax({
					type: 'POST',
					url: url,
					data: data,
					showNoSuggestionNotice: true,
					dataType: 'json',
			    beforeSend: function(jqXHR) {
		        jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
			    },
					success: function(data,responseText,jqXHR) {
						if( jqXHR.status == 204 ) {
							that.debug('sorry, here is nothing to do for me. (Token problem?)')
							return false;
						}
						if( jqXHR.status == 404 ) {
							that.debug('sorry, here is nothing to show you.')
							return false;
						}
						if( jqXHR.status == 403 ) {
							that.debug('sorry, this is no place for you.')
							return false;
						}
						//debug(data);
						if( data.script )	{
							eval(data.script);
						}
					},
					error: function() {
						that.debug('something is wrong....anything buggy?');
					},
					complete: function() {
					}
			});
		},
   };

    $.cssOrderAttributeAdmin = function(options) {
    	console.log("starte cssOrderAttribute");
    	$.cssOrderAttributeAdmin = new cssOrderAttributeAdminClass(options);
    	$.cssOrderAttributeAdmin.register();
    	return $.cssOrderAttributeAdmin;
    };
})(jQuery);
$(function() {
	$.cssOrderAttributeAdmin();
});


